/* Object-Oriented Programming in C++   */
/* Student Name: Abdullah S. Al-Salloum */
/* Instructor: Dr. Ashraf Anwar         */

/* Homework Assignment #3               */
/* Modifying the program to let the     */
/* the user to enter elephants prices   */
/* and show the prices sum on the       */
/* screen. **EDITED EDITION**           */


#include<iostream>
#include<string>
using namespace std;

struct Elephant {
	string name;
	float price;
	Elephant* next;
};

void print_elephants( const Elephant* ptr );
Elephant* get_elephants();
void sumPrices ( const Elephant* ptr );
void free_list(const Elephant* prt);

int main() {
	Elephant* start;
	start = get_elephants();
	print_elephants( start );
	sumPrices( start );
	free_list( start );
	return 0;
}

Elephant* get_elephants() {
	Elephant *current, *first;
	int response;
	current = first = new Elephant;
	cout << "\nNAME: ";
	cin >> current->name;
	cout << "\nPRICE: ";
	cin >> current->price;
	cout << "\nADD another? ( 1 == yes, 0 == no): ";
	cin >> response;

	while ( response == 1 ) {
		current = current->next = new Elephant;
		cout << "\nNAME: ";
		cin >> current->name;
		cout << "\nPRICE: ";
		cin >> current->price;
		cout << "\nADD another ( 1 == yes, 0 == no): ";
		cin >> response;
	}

	current->next = 0;
	return first;
}

void print_elephants( const Elephant* ptr ) {
	int count = 1;
	cout << "\n\n\n";
	while ( ptr != 0 ) {
		cout << "Elephant number " << count++
			 << "is " << ptr->name << '\n';
		ptr = ptr->next;
	}
}

void sumPrices ( const Elephant* ptr ) {
	float sum = 0;
	while ( ptr !=0 ) {
		sum = sum + ptr->price;
		ptr = ptr->next;
	}
	cout << "Sum of elephants' prices is: "<< sum;
}

void free_list ( const Elephant* ptr ) {
	const Elephant* temp_ptr;
	while ( ptr != 0 ) {
		temp_ptr = ptr->next;
		delete ptr;
		ptr = temp_ptr;
	}
}